from bs4 import BeautifulSoup
import os # built-in package
import requests


class Carrefour_Items:
    _X_ibm_client_id = os.getenv("_X_ibm_client_id")
    _X_ibm_client_secret = os.getenv("_X_ibm_client_secret")

    @classmethod
    def Get_X_ibm_client_id(Carrefour_Items_class):
        return Carrefour_Items_class._X_ibm_client_id

    @staticmethod
    def Get_X_ibm_client_secret():
        return Carrefour_Items._X_ibm_client_secret


def request_Carrefour_Items(search_text):
    headers = {
        'accept': "application/json",
        'content-type': "application/json",
        'x-ibm-client-id': Carrefour_Items.Get_X_ibm_client_id(),
        'x-ibm-client-secret': Carrefour_Items.Get_X_ibm_client_secret()
    }
    query = "{\"queries\":[{\"query\":\"" + search_text + "\",\"field\":\"barcodeDescription\"}]}"
    return requests.post("https://api.fr.carrefour.io/v1/openapi/items", data=query, headers=headers).json()


def request_Carrefour_Drive(barcode):
    data = requests.get("https://courses-en-ligne.carrefour.fr/{}".format(barcode),
                        cookies={'Cookie': 'store=113'}).text
    soup = BeautifulSoup(data, "html.parser")
    image_link = soup.find(class_="carousel-content-image")
    if image_link is None:
        return None, None, None
    image_link = image_link.get("src")
    price = soup.find(class_="product-pricing__main-price").get_text().strip()
    price_per_kilo = soup.find(class_="product-pricing__main-ppu").get_text().strip()
    return image_link, price, price_per_kilo


def request_OpenFoodFacts(barcode):
    return requests.get("https://world.openfoodfacts.org/api/v0/product/{}.json".format(barcode)).json()
