import api_requests
import product_info_window
import tkinter as tk # https://docs.python.org/3/library/tkinter.html#module-tkinter

class Application(tk.Frame):
    def __init__(self, master=None):
        super().__init__(master)

        self.current_item_list = []

        self.grid(sticky="nswe")
        self.grid_columnconfigure(index=0, weight=1)
        self.grid_columnconfigure(index=1, weight=1)
        self.grid_rowconfigure(index=0, weight=1)
        self.grid_rowconfigure(index=1, weight=1)
        self.grid_rowconfigure(index=2, weight=5)
        self.grid_rowconfigure(index=3, weight=1)
        self.create_widgets()

    def create_widgets(self):
        self.search_label = tk.Label(self, text="Type a search query:")
        self.search_label.grid(row=0, column=0, sticky="nswe")

        self.query_entry = tk.Entry(self)
        self.query_entry.grid(row=0, column=1, sticky="nswe")

        self.search_button = tk.Button(self, text="Search", command=self.search)
        self.search_button.grid(row=1, sticky="nswe")

        self.quit = tk.Button(self, text="QUIT", fg="red", command=root.destroy)
        self.quit.grid(row=3, sticky="nswe")

        self.search_result_frame = tk.Frame(self)
        self.search_result_frame.grid(row=2, column=0, columnspan=2, sticky="nswe")

    def search(self):
        if self.query_entry.get() != "":
            row = 0
            self.clear_result_frame()
            content = api_requests.request_Carrefour_Items(self.query_entry.get())
            self.current_item_list = content["list"]
            for item in content["list"]:
                entry_label = tk.Label(self.search_result_frame, text=item["name"])
                entry_label.grid(row=row, column=0)

                item_copy = item.copy()
                more_button = tk.Button(self.search_result_frame, text="More...",
                                        command=lambda item_display=item_copy: self.create_product_info_window(
                                            item_display))
                more_button.grid(row=row, column=1)
                row += 1

    def clear_result_frame(self):
        for widget in self.search_result_frame.winfo_children():
            widget.destroy()

    def create_product_info_window(self, item):
        new_root = tk.Toplevel()
        product_info_window.ProductInfoWindow(item, new_root)

root = tk.Tk()
root.grid()
app = Application(master=root)
root.grid_columnconfigure(index=0, weight=1)
root.grid_rowconfigure(index=0, weight=1)
app.mainloop()
