import tkinter as tk
from PIL import ImageTk
from PIL import Image
from io import BytesIO
import api_requests
import requests

class ProductInfoWindow(tk.Frame):
    def __init__(self, product_info, master=None):
        super().__init__(master)
        self.grid(sticky="nswe")
        # self.grid()

        self.name_label = tk.Label(self, text="Product name : {}".format(product_info["name"]))
        self.name_label.grid(row=0)

        self.desc_label = tk.Label(self, text=product_info["name"])
        self.desc_label.grid(row=1)

        self.quantity_label = tk.Label(self, text="{} {}".format(product_info["capacity_volume"],
                                                                 product_info["capacity_unit"]))
        self.quantity_label.grid(row=2)

        self.brand_label = tk.Label(self, text="Brand : {}".format(product_info["brand"]))
        self.brand_label.grid(row=3)

        image_link, price, price_per_kilo = api_requests.request_Carrefour_Drive(product_info["gtin"])

        if image_link is not None:
            self.price_label = tk.Label(self, text="Price : {}".format(price))
            self.price_label.grid(row=4)

            self.price_quantity_label = tk.Label(self, text=price_per_kilo)
            self.price_quantity_label.grid(row=5)

            r = requests.get("https://www.carrefour.fr{}".format(image_link))
            self.image = Image.open(BytesIO(r.content))

            self.image_tk = ImageTk.PhotoImage(self.image)
            self.canvas_image = tk.Canvas(self)
            self.canvas_image.create_image(0, 0, image=self.image_tk, anchor="nw")
            self.canvas_image.grid(row=6, rowspan=5, columnspan=5)

        else:
            request_result = api_requests.request_OpenFoodFacts(product_info["gtin"])

            self.unavailable_label = tk.Label(self, text="Unavailable in Pau")
            self.unavailable_label.grid(row=4)

            if request_result["status"] == 1:
                # image_link = request_result["product"]["selected_images"]["front"]["display"]["fr"]
                image_link = request_result["product"]["image_url"]
                r = requests.get(image_link)
                self.image = Image.open(BytesIO(r.content))

                self.image_tk = ImageTk.PhotoImage(self.image)
                self.canvas_image = tk.Canvas(self)
                self.canvas_image.create_image(0, 0, image=self.image_tk, anchor="nw")
                self.canvas_image.grid(row=5, rowspan=5, columnspan=5)
            else:
                self.image_unavailable_label = tk.Label(self, text="Picture not available")
                self.image_unavailable_label.grid(row=5)
